/**********************************************************************
  sim Console (Pseudo Console device)
  $Id: dev_console.c,v 1.1 2002/08/28 17:08:50 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int dev_console( unsigned int port , struct MACHINE_RESOURCE *mres )
{
  int cmd ;
  
  cmd=mres->mem[seg(CONSOLE_OUT_CMD+3)][lad(CONSOLE_OUT_CMD+3)] ;
  if( cmd != 0 ){
    putc(cmd,stdout) ;
    mres->mem[seg(CONSOLE_OUT_CMD+3)][lad(CONSOLE_OUT_CMD+3)]=0 ;
  }

  return( NORMAL_EXIT ) ;
}


int dev_console_init( struct MACHINE_RESOURCE *mres )
{
  return( NORMAL_EXIT ) ;
}
