/************************************************************************
  sim PIC (Pseudo荞݃Rg[)
  $Id: dev_pic.h,v 1.1 2002/08/28 17:08:50 tane Exp $
************************************************************************/

/*** sim PIC device ***/
#define PIC_MASTER_PORT0     0x80000020
#define PIC_MASTER_PORT1     0x80000021
#define PIC_SLAVE_PORT0      0x800000a0
#define PIC_SLAVE_PORT1      0x800000a1

struct PIC_REG_struct{
  int           state ;
  unsigned char icw1 ;
  unsigned char icw2 ;
  unsigned char icw3 ;
  unsigned char icw4 ;
  unsigned char IMR  ; /* same ocw1 */
  unsigned char ocw2 ;
  unsigned char ocw3 ;
  unsigned char IRR ;
  unsigned char ISR ;
} ;

struct PIC_REG_struct PIC_REG[2] ;

#define PIC_IR00_INT  0x0001
#define PIC_IR01_INT  0x0002
#define PIC_IR02_INT  0x0004
#define PIC_IR03_INT  0x0008
#define PIC_IR04_INT  0x0010
#define PIC_IR05_INT  0x0020
#define PIC_IR06_INT  0x0040
#define PIC_IR07_INT  0x0080
#define PIC_IR08_INT  0x0100
#define PIC_IR09_INT  0x0200
#define PIC_IR10_INT  0x0400
#define PIC_IR11_INT  0x0800
#define PIC_IR12_INT  0x1000
#define PIC_IR13_INT  0x2000
#define PIC_IR14_INT  0x4000
#define PIC_IR15_INT  0x8000

int dev_pic( unsigned int port , struct MACHINE_RESOURCE *mres ) ;
int dev_pic_init( struct MACHINE_RESOURCE *mres ) ;
int dev_pic_set_interrupt(int dev_int) ;
int dev_pic_prio_int() ;
