/**********************************************************************
  [v[uR}h
  $Id: prob_cmd.c,v 1.2 2002/08/28 17:08:53 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int prob_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i ;

  if( tk_pt->pt[1]==NULL ){
    if( MemprobeBuf.num==0 ){
    }else{
      SYSMSG("---- memory probe ----\n") ;
      for( i=0 ; i<MemprobeBuf.num ; i++ ){
	SYSMSG("0x%08x size=0x%08x",
	       MemprobeBuf.adrs[i],
	       MemprobeBuf.size[i]) ;
	if( MemprobeBuf.label[i]!=NULL ){
	  SYSMSG(" : %s",MemprobeBuf.label[i]) ;
	}
	SYSMSG("\n") ;
      }
    }
    return(NORMAL_EXIT) ;
  }

  if( MemprobeBuf.num <= MEMPROBE_BUFSIZE ){
    if( tk_pt->pt[3]!=NULL ){
      MemprobeBuf.label[MemprobeBuf.num]=malloc(strlen(tk_pt->pt[3])+1) ;
      if( MemprobeBuf.label[MemprobeBuf.num]==NULL ){
	return( MEM_ALLOC_ERROR ) ;
      }
      strcpy(MemprobeBuf.label[MemprobeBuf.num],tk_pt->pt[3]) ;
    }

    MemprobeBuf.adrs[MemprobeBuf.num]=exatoi(tk_pt->pt[1]) ;
    if( tk_pt->pt[2]==NULL ){
      MemprobeBuf.size[MemprobeBuf.num]=1 ;
    }else{
      int n ;
      n=exatoi(tk_pt->pt[2]) ;
      if( n<1 ){
	SYSMSG("Size is Invalid. (%d)\n",n) ;
	return( NORMAL_EXIT ) ;
      }
      MemprobeBuf.size[MemprobeBuf.num]=n ;
    }
    MemprobeBuf.num++ ;
  }else{
    SYSMSG("probe point is full.\n") ;
  }

  return(NORMAL_EXIT) ;
}
