/**********************************************************************
  sim VRAM (Pseudo Video RAM )
  $Id: dev_vram.h,v 1.1 2002/08/28 17:08:50 tane Exp $
**********************************************************************/

/*** Graphic device ***/
#ifdef SUPPORT_GRAPHIC_DEVICE

#include "gdevlib.h"

#define GRAPHIC_VRAM_SYNC     0x8000ff40
#define GRAPHIC_VRAM_TOP      0xf0000000
#define GRAPHIC_VRAM_WIDTH    2048
#define GRAPHIC_VRAM_HEIGHT   480
#define GRAPHIC_VRAM_DEPTH    4

#define GRAPHIC_SCREEN_WIDTH  640
#define GRAPHIC_SCREEN_HEIGHT 480
#define GRAPHIC_NAME          "PPCSIM Graphic Device"

struct VRAM_PIX *gdev_vp ;

#define GdevAccessBufSize    1
struct GdevAccessBuffer{
  int c ;
  int n ;
  unsigned int *buf ;
} GdevBuf ;

void actionfunc(int c) ;
void SyncGdevDraw(struct MACHINE_RESOURCE *mres) ;

int dev_vram( unsigned int port , struct MACHINE_RESOURCE *mres ) ;
int dev_vram_init( struct MACHINE_RESOURCE *mres ) ;

#endif

