/**********************************************************************
  ELFt@C[hR}h
  $Id: eload_cmd.c,v 1.2 2002/08/28 17:08:51 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	eload_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int    res ;
int    id ; 

 id=proc_list.cur_id ;

 if( tk_pt->num<2 ){
   SYSMSG("Too few argument(s)\n") ;
   return(SPECIFY_ERROR) ;
 }

 if( mode==0 ){
   res=elf_load(  &proc_list.proc[id], tk_pt->pt[1] ) ;
   if( res != NORMAL_EXIT ){
     SYSMSG("Failed to load ELF file(%s)\n",tk_pt->pt[1]) ;
     return(FILE_OPEN_ERROR) ;
   }
 }else if( mode==1 ){
   res=elf_info(  &proc_list.proc[id], tk_pt->pt[1] ) ;
   if( res != NORMAL_EXIT ){
     SYSMSG("Failed to load ELF file(%s)\n",tk_pt->pt[1]) ;
     return(FILE_OPEN_ERROR) ;
   }
 }
 return(NORMAL_EXIT) ;
 
}
