/************************************************************************
  PPCSIMwb_
  $Id: ppcsim.h,v 1.5 2002/08/28 17:08:52 tane Exp $
************************************************************************/

/************************************************************************
  g[XqXg֘A
************************************************************************/

struct TRACE_BUF_STRUCT{
  unsigned int  pc ;
  unsigned int  inst ;
} ;
struct TRACE_STRUCT{
  int ptr   ;
  int size  ;
  struct TRACE_BUF_STRUCT *buf ;
} ;

struct TRACE_STRUCT trace ;

long long int iexe_count  ;

#define	DEFAULT_TRACE_SIZE 256

/************************************************************************
  Pass|Cg
************************************************************************/
int	pp_msg  ;
#define PP_DUMP_PC   0
#define PP_DUMP_GPR  1
#define PP_DUMP_ALL  2

/************************************************************************
  s[h
************************************************************************/
/*                                     0x00_00_00_00 */
/*                                              | || */
/*                                              | || */
/*                                              | || */
#define GO_EXEC_MODE    0x0100 /*---------------+ || */
#define GO_STEP_MODE    0x0010 /*-----------------+| */
#define GO_ALL_DUMP     0x0004 /*------+-----------+ */
#define GO_GPR_DUMP     0x0002 /*------+             */
#define GO_PC_DUMP      0x0001 /*------+             */

/***********************************************************************/
int	verbose ;
int	truss_stat ;
int	trace_stat ;
#define TRACE_OFF  0x0
#define TRACE_PC   0x1
#define TRACE_GRP  0x2
#define TRACE_ALL  0x3

/************************************************************************
  V~[VbZ[WO
************************************************************************/
char	*simlog  ;
FILE	*simmsgfp ;
#define	DEFAULT_SIMMSG_OUT stderr

#ifdef DEBUG
#define DEBUGMSG(fmt,...)   fprintf(simmsgfp, "Debug(%s:%d@%s):" fmt,__FILE__,__LINE__, __func__, __VA_ARGS__)
#else
#define DEBUGMSG(fmt,...)
#endif

#define SYSMSG(...)   fprintf(simmsgfp,__VA_ARGS__)
#define SYSMSGLL(v,l) printll(simmsgfp,v,l)

#define SYSERR(...)   fprintf(stderr,__VA_ARGS__)

/************************************************************************
  VOinh
************************************************************************/
int  sig_int ;
void init_sighandl_ppcsim() ;
void set_sighandl_ppcsim() ;
void sighandl_ppcsim(int) ;

