/**********************************************************************
  traceR}h
  $Id: trace_cmd.c,v 1.3 2002/08/28 17:08:53 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int trace_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
static unsigned char *msg[]={"Trace OFF","Trace PC","Trace GPR and others",
                             "Trace all Registers"} ;

  if( tk_pt->pt[1]==NULL ){
    SYSMSG("Current tracing state=%s\n",msg[trace_stat] ) ;
    return(NORMAL_EXIT) ;
  }
  if(       strcmp(tk_pt->pt[1],"pc" )==0 ){
    trace_stat=TRACE_PC ;
  }else if( strcmp(tk_pt->pt[1],"gpr")==0 ){
    trace_stat=TRACE_GRP ;
  }else if( strcmp(tk_pt->pt[1],"all")==0 ){
    trace_stat=TRACE_ALL ;
  }else if( strcmp(tk_pt->pt[1],"off")==0 ){
    trace_stat=TRACE_OFF ;
  }else{
    SYSMSG("Invalid argument %s\n",tk_pt->pt[1] ) ;
  }
  
  return(NORMAL_EXIT) ;
}

